<?php
/*
 * list.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */

include ("include/header_info.php");


/**********************************************************************************************
 *  This page displays the 
 *	- File List [Currently Obsolete though the code remains] (OR)
 *	- File Contents [List of stings in a file]  (OR)
 *	- File's Untranslated contents  (OR)
 *	- All Strings [in all files]  (OR)
 *	- All untranslated stings [in all files]
 *
 *								AUTHOR: Khader Abbeb N
 **********************************************************************************************
*/

// 		Allowing only Logged in user to make suggestions. 

// 	Comment the below block if you want any user (registeres users and 'Guest' users) to be able submit 
//	their suggestions

// ---> Start of block for Check for User login <---

/*
*/
// ---> End of block for Check for User login <---

	include ('include/functions_common.php');
	include_once ('include/functions_stat.php');
//	include ('include/functions_list.php');
	include ('include/functions_list_translate.php');
	$db	= dbConnect();
	insertCheckAuth(false);

	// Variables used for page listing

	$category	= $_GET["category"];	// Category type : 'all' or 'untrans' 
	$file_list	= $_GET["file_list"];	// File Wise Viewing
	$file_id	= $_GET["file_id"];	// Selected File Id
	$funtrans	= $_GET["funtrans"];	// View only Untranslated strings in a File
	$root		= getParentId($file_id);	// Main page contents' section-root

	$page		= $_GET["page"];	// Page Number
	$next_pg	= $page+1;		// Next Page Number
	$prev_pg	= $page-1;		// Previous Page Number
	$last_pg	= $_GET["last_pg"];	// Used while submitting multiple suggestions in the last page
	$rec_per_page	= 100;			// Number of records displayed per page

	$edit_all	= $_GET["edit_all"];

	$show_input_method_selection_box	 = TRUE;

	// Variables used during submission of suggestion
	$user_sug	= $_POST["user_sug"];		// User Suggestion
	$check_valid	= $_POST["check_valid"];	// Should the suggestion be validated?
	$string_id	= $_POST["string_id"];		// String Id
	$submit_all	= $_POST["submit_all"];		// Submit suggestion for many/all strings in a page
	$fuzzy		= $_POST["fuzzy"];		// Is the suggestion fuzzy?
	$fuzzy		= ($fuzzy) ? 1 : 0;
	$lang_sug	= $_POST["lang_sug"];		// Language of suggestion

	if (is_numeric($page))
	{
        if ($page >0)
        {   // Lower Limit for Display of Records. Used in LIMIT of "$sql_list"
            $lower_limit	= ($page -1) * $rec_per_page;	

            if ($page >1)
            {
                $prev_pg_lower_limit	= ($prev_pg -1) * $rec_per_page;
                if ($last_pg)
                    $prev_pg_lower_limit	= $lower_limit;
            }
            else
                $prev_pg_lower_limit	= 0;	

        }
    }
    else
    {
        echo "Invalid Page Number<br>";
    }

    if ($category)
    {
        if ($_GET["lang"])
        {
            $lang	= $_GET["lang"];
            if ($lang == "all")
            {
                setcookie("lang_id");
            }
            else
            {
                setcookie("lang_id",$lang);
            }
        }
        else
        {
            $lang	= $_COOKIE["lang_id"];
        }
        $lang_list	= getAllLangList();
    }

    /*
     *   The "$sql_list" query retrives all the strings to be displayed based on the user choice of the options 
     * mentioned above. It is LIMIT-ed based on page number ($page).
     *  The "$sql_count" gives the count or the total number of records returned for the "$sql_list" query without the 
     * LIMIT used in it.
     *  The "$sql_list_id" gives the list of strings in the previous page. It is used when one uses the "Submit All"
     * option to submit multiple suggestions and simultaneously move to the next page.
     */

    if ($file_list)
    {
        if ($file_id)
        {
            if($funtrans=='yes') 	// File's Untranslated Contents
            {
                $sql_list  	= "select t.string_id, t.string_value, c.context_id, c.valid_sug_id ".
                    "from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id = c.string_id and c.valid_sug_id='-1' and ".
                    "c.file_id='$file_id' ".
                    "order by t.string_id limit $lower_limit, $rec_per_page";

                $sql_list_id= "select t.string_id ".
                    "from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id = c.string_id and c.valid_sug_id='-1' and ".
                    "c.file_id='$file_id' ".
                    "order by t.string_id limit $prev_pg_lower_limit, $rec_per_page";

                $sql_count 	= "select count(t.string_id) from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id=c.string_id and c.valid_sug_id='-1' and ".
                    "c.file_id='$file_id'";
            }
            else if($funtrans=='fuzzy')
            {
                $sql_list  	= "select t.string_id, t.string_value, c.context_id, c.valid_sug_id ".
                    "from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id = c.string_id and is_fuzzy='1' and ".
                    "c.file_id='$file_id' ".
                    "order by t.string_id limit $lower_limit, $rec_per_page";

                $sql_list_id= "select t.string_id ".
                    "from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id = c.string_id and is_fuzzy='1' and ".
                    "c.file_id='$file_id' ".
                    "order by t.string_id limit $prev_pg_lower_limit, $rec_per_page";

                $sql_count 	= "select count(t.string_id) from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id=c.string_id and is_fuzzy='1' and ".
                    "c.file_id='$file_id'";
            }
            else 	// File's Contents
            {
                $sql_list  	= "select t.string_id, t.string_value, c.context_id, c.valid_sug_id ".
                    "from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id = c.string_id and c.file_id='$file_id' order by t.string_id ".
                    "limit $lower_limit, $rec_per_page";

                $sql_list_id	= "select t.string_id ".
                    "from $table_string_list as t, $table_string_context as c ".
                    "where t.string_id = c.string_id and c.file_id='$file_id' order by t.string_id ".
                    "limit $prev_pg_lower_limit, $rec_per_page";

                $sql_count 	= "select count(t.string_id) from $table_string_list as t, $table_string_context as c".
                    " where t.string_id=c.string_id and c.file_id='$file_id' ";
            }
        }
        else		// File List
        {
            $sql_list	= "select distinct node_id, node_name from $table_file_details ".
                "where is_po = 1 ".
                "order by node_id limit $lower_limit, $rec_per_page";
            $sql_count	= "select count(distinct node_id) from $table_file_details ".
                "where is_po = 1 ";
        }
    }
    else if($category=="untrans")	// All Untranslated string
    {
        if ($lang && $lang!="all")
        {
            $sql_list	= "select distinct t.string_id, t.string_value ".
                "from $table_string_list as t, $table_string_context as c, $table_file_details as f ".
                "where f.lang ='$lang' and f.node_id=c.file_id ".
                "and t.string_id=c.string_id and c.valid_sug_id='-1' ".
                "order by string_id limit $lower_limit, $rec_per_page";

            $sql_list_id= "select distinct t.string_id ".
                "from $table_string_list as t, $table_string_context as c, $table_file_details as f ".
                "where f.lang ='$lang' and f.node_id=c.file_id ".
                "and t.string_id=c.string_id and c.valid_sug_id='-1' ".
                "order by string_id limit $prev_pg_lower_limit, $rec_per_page";

            $sql_count	= "select count(distinct string_id) ".
                "from $table_string_context as c, $table_file_details as f ".
                "where f.lang='$lang' and f.node_id=c.file_id and c.valid_sug_id='-1' ";

        }
        else
        {
            $sql_list	= "select distinct t.string_id, t.string_value ".
                "from $table_string_list as t, $table_string_context as c ".
                "where t.string_id=c.string_id and c.valid_sug_id='-1' ".
                "order by string_id limit $lower_limit, $rec_per_page";

            $sql_list_id= "select distinct t.string_id ".
                "from $table_string_list as t, $table_string_context as c ".
                "where t.string_id=c.string_id and c.valid_sug_id='-1' ".
                "order by string_id limit $prev_pg_lower_limit, $rec_per_page";

            $sql_count	= "select count(distinct string_id) from $table_string_context ".
                "where valid_sug_id='-1' ";
        }	
    }
    else if($category=="fuzzy")	// All Fuzzy string
    {
        if ($lang && $lang!="all")
        {
            $sql_list	= "select distinct t.string_id, t.string_value ".
                "from $table_string_list as t, $table_string_context as c, $table_file_details as f ".
                "where f.lang ='$lang' and f.node_id=c.file_id ".
                "and t.string_id=c.string_id and c.is_fuzzy='1'".
                "order by string_id limit $lower_limit, $rec_per_page";

            $sql_list_id= "select distinct t.string_id ".
                "from $table_string_list as t, $table_string_context as c, $table_file_details as f ".
                "where f.lang ='$lang' and f.node_id=c.file_id ".
                "and t.string_id=c.string_id and c.is_fuzzy='1'".
                "order by string_id limit $prev_pg_lower_limit, $rec_per_page";

            $sql_count	= "select count(distinct string_id) ".
                "from $table_string_context as c, $table_file_details as f ".
                "where f.lang='$lang' and f.node_id=c.file_id and c.is_fuzzy='1'";

        }
        else
        {
            $sql_list	= "select distinct t.string_id, t.string_value ".
                "from $table_string_list as t, $table_string_context as c ".
                "where t.string_id=c.string_id and c.is_fuzzy='1'".
                "order by string_id limit $lower_limit, $rec_per_page";

            $sql_list_id= "select distinct t.string_id ".
                "from $table_string_list as t, $table_string_context as c ".
                "where t.string_id=c.string_id and c.is_fuzzy='1'".
                "order by string_id limit $prev_pg_lower_limit, $rec_per_page";

            $sql_count	= "select count(distinct string_id) from $table_string_context ".
                "where is_fuzzy='1'";
        }
    }
    else if ($category == "all")		// All Strings
    {
        if ($lang && $lang != "all")
        {
            $sql_list	= "select distinct l.string_id, l.string_value ".
                "from $table_string_list as l, $table_string_context as c, $table_file_details as f ".
                "where c.string_id=l.string_id and f.node_id=c.file_id and f.lang='$lang' ".
                "order by string_id limit $lower_limit, $rec_per_page";
            $sql_list_id= "select distinct l.string_id ".
                "from $table_string_list as l, $table_string_context as c, $table_file_details as f ".
                "where c.string_id=l.string_id and f.node_id=c.file_id and f.lang='$lang' ".
                "order by string_id ".
                "limit $prev_pg_lower_limit, $rec_per_page";
            $sql_count	= "select count(distinct l.string_id) ".
                "from $table_string_list as l, $table_string_context as c, $table_file_details as f ".
                "where c.string_id=l.string_id and f.node_id=c.file_id and f.lang='$lang'";
        }
        else
        {
            $sql_list	= "select string_id, string_value from $table_string_list order by string_id ".
                "limit $lower_limit, $rec_per_page";
            $sql_list_id= "select string_id from $table_string_list order by string_id ".
                "limit $prev_pg_lower_limit, $rec_per_page";
            $sql_count	= "select count(string_id) from $table_string_list";
        }
    }

    $sel_file_id	= $file_id;
    if (!$sel_file_id && $category)
        $sel_file_id	= -1;			// No such file


    if ($submit_all)
    {
        $result_list_id	= mysql_query ($sql_list_id);

        if ($row_list_id = mysql_fetch_row($result_list_id))
        {
            do
            {
                $select_sug		= "";
                $valid_sug		= "";
                $user_sug		= "";
                $fuzzy		    = "";
                $string_id		= $row_list_id[0];
                $user_sug_temp	= "sug_"    . $string_id;
                $select_sug_temp	= "select_" . $string_id;
                $valid_sug_temp	= "valid_"  . $string_id;
                $fuzzy_temp		= "fuzzy_"  . $string_id;
                $select_sug		= $_POST["$select_sug_temp"];

                if ($select_sug == "yes")
                {
                    $valid_sug	= $_POST["$valid_sug_temp"];
                    $fuzzy		= $_POST["$fuzzy_temp"];
                    $fuzzy		= ($fuzzy) ? 1 : 0;
                    if (!get_magic_quotes_gpc())
                    {
                        $user_sug	= addslashes($_POST["$user_sug_temp"]);
                    }
                    else
                    {
                        $user_sug	= $_POST["$user_sug_temp"];
                    }

                    if($user_sug)
                        SubmitSuggestion ($string_id, $user_sug, $lang_sug, $fuzzy, $sel_file_id, $valid_sug);
                    
                }

            }while($row_list_id = mysql_fetch_row($result_list_id));
        }

    }
    else if ($string_id && $user_sug)
    {
        SubmitSuggestion ($string_id, $user_sug, $lang_sug, $fuzzy, $sel_file_id, $check_valid);
    }

    $result_count	= mysql_query($sql_count);
    $list_result   	= mysql_query($sql_list);
    $row_count	= mysql_fetch_row($result_count);
    $total_rec	= $row_count[0];			// Total Number of Records
    $total_pages	= $total_rec/$rec_per_page;
    $total_pages	= ceil($total_pages);			// Total Number of Pages

    if ($file_id)
    {
        $file_lang	= getLang($file_id);
    }


    include ("head.php");					// Start HTML page
?>

<style type="text/css">
<!--
.ver {
    font-family : Verdana, Arial, Helvetica, sans-serif;
}
.siz12{
    font-size : 12px;
}
.fname {
    font-family : Courier;
    color : gray;
    padding-left : 10px;
}
.list_tab{
    margin: 0px;
    margin-bottom: 3px;
}
// -->
</style>
<script type="text/javascript" src="scripts/list.js"> </script>
<script type="text/javascript" src="scripts/common.js"> </script>
<script type="text/javascript" src="scripts/IndicSupport.js"> </script>

    <script type="text/javascript" >
    <!--
        // -->
        </script>

<?php
    include ("body.php");	// Begin the <BODY> of HTML page
?>

<!-- 	The Navigation Bar -->

   <ul id="navibar">
    <li class="wikilink"><a href="main.php">Home</a></li>

<?php
    if($category == "untrans") 
        echo '<li class="current"> ';
    else 
        echo '<li class="wikilink"> ';
?>	 
        <a href="list.php?category=untrans&amp;page=1">Untranslated Strings</a></li>

<?php
    if($category == "fuzzy") 
        echo '<li class="current"> ';
    else 
        echo '<li class="wikilink"> ';
?>	 
        <a href="list.php?category=fuzzy&amp;page=1">Fuzzy Strings</a></li>


<?php
    if($category=="all") 
    {
        echo '<li class="current"> ';

        echo '<a href="list.php?category=all&amp;page=1">All Strings</a></li>';
    }
    if ($file_list)
    { 
        if($file_id) 
        {
            /*	echo "<li class=\"wikilink\"> ";
                echo "<a href=\"list.php?file_list=$file_list&amp;page=1\">File List</a></li>";
             */
            echo '<li class="current"> ';
            echo "<a href=\"list.php?file_list=$file_list&amp;file_id=$file_id&amp;page=1\">".
                'File Contents</a></li>';
        }
        else
        {
            echo '<li class="current"> ';
            echo "<a href=\"list.php?file_list=$file_list&amp;page=1\">".
                'File List</a></li>';
        }

        echo '<li class="wikilink">';
        echo "<a href=\"main.php?root=$root\">Back</a></li>";
    }
?>

    <li class="wikilink"><a href="help.php">Help</a></li>

   </ul>

<!-- 	End of Navigation Bar -->
<div id="pageline"><hr style="display:none;"></div>

</div> <!-- End of Div started in body.php -->


<div style="padding:5px">
<?php

    // Storing Previous and Next link's HTML tags in PHP variable for ease of use (note: HTML tags are incomplete)

    $link_current_url	= $_SERVER["REQUEST_URI"];
    $find			= "&scrollPos=".$_GET["scrollPos"];
    $replace		= "";
    $link_current_url	= str_replace ($find, $replace, $link_current_url);
    $link_current		= htmlspecialchars($link_current_url);

    if($page>1)
    { 
        $find	= "&page=$page";
        $replace	= "&page=$prev_pg";
        $link_prev	= str_replace ($find, $replace, $link_current_url);
        $link_prev	= htmlspecialchars($link_prev);
    }
    if($page<$total_pages) 
    {
        $find	= "&page=$page";
        $replace	= "&page=$next_pg";
        $link_next	= str_replace ($find, $replace, $link_current_url);
        $next_set	= $link_next. "&edit_all=$edit_all";
        $link_next	= htmlspecialchars($link_next);
        $next_set	= htmlspecialchars($next_set);
    }
    else
    {
        $next_set	= $link_current_url. "&last_pg=1&edit_all=$edit_all";
    }

    function insertLangForm($lang, $lang_list)
    {
        echo '<form name="lang_form" method="GET" action="">';
        echo '<div class="langbar">';
        echo 'Language ';
        echo '<select name="lang_sel" class="submit_sel_file" '.
            'onChange="setLang(\''.$lang.'\',\''.$_GET["edit"].'\');">';
        $selected	= "";
        if (!$lang)
        {
            $selected	= "selected";
        }
        echo '<option value="all" '.$selected .' >All</option>';
        foreach ($lang_list as $lang_value)
        {
            $selected	= "";
            if ($lang_value	== $lang)
                $selected = "selected";
            if($lang_value) {	
                echo '<option value="'.$lang_value.'" '.$selected .'>'.getLangName($lang_value).
                     " ($lang_value)".'</option>';
            }
        }
        echo '</select>';
        echo '</div>';
        echo '</form>';
    }

    if ($row_list = mysql_fetch_row($list_result))
    {
        $upper_limit	= $page*$rec_per_page;
        if ($upper_limit>$total_rec) $upper_limit = $total_rec;

?>
        <table class="list_tab" width="100%"  border=0 cellpadding="5" cellspacing=0  >
        <tr valign="top">
            <td width="35%" align="left">
<?php
        if ($file_id)
        {
            echo 'Language of Translation : <b>'.getLangName($file_lang) ." ($file_lang)</b>";
                /*
                include ("include/functions_main.php");
                $parent_id	= getParentId($file_id);
                insert_path($parent_id, "root");
                 */
        }
        else if($file_list)
        { 
            echo "Please select a File";
        }
        else
        {
            insertLangForm($lang, $lang_list);
        }
?>
            </td>
            <td width="30%" align="center" >
<?php		
        echo "Displaying ". ($lower_limit+1). 
            " to $upper_limit of $total_rec ( Page : $page )";
?>
            </td>
            <td width="35%" align="right"> 
<?php
        if($file_id)
        {
            $file_name	= getNodeName($file_id);
            echo "<b>$file_name </b>";
            if($funtrans=='yes')
            {
                echo "(<a class=\"siz12\" href=\"list.php?file_list=yes&amp;".
                    "file_id=$file_id&amp;page=1\">View All</a>, ".
                    "<a class=\"siz12\" href=\"list.php?file_list=yes&amp;".
                    "file_id=$file_id&amp;funtrans=fuzzy&amp;page=1\">View Fuzzy</a>)";
            }
            else if($funtrans=='fuzzy')
            {
                echo "(<a class=\"siz12\" href=\"list.php?file_list=yes&amp;".
                    "file_id=$file_id&amp;page=1\">View All</a>, <a class=\"siz12\" href=\"list.php?file_list=yes&amp;".
                    "file_id=$file_id&amp;funtrans=yes&amp;page=1\">View Untranslated</a>)";
            }
            else	
            {
                echo "(<a class=\"siz12\" href=\"list.php?file_list=yes&amp;".
                    "file_id=$file_id&amp;funtrans=yes&amp;page=1\">View Untranslated</a>, ".
                    "<a class=\"siz12\" href=\"list.php?file_list=yes&amp;".
                    "file_id=$file_id&amp;funtrans=fuzzy&amp;page=1\">View Fuzzy</a>)";
                    
            }
            if($_SESSION["user_role"]=="validator") 
            {
                echo "&nbsp;(<a class=\"siz12\" href=\"edit_poheader.php?" .
                    "selected_file_id=$file_id\">Edit header</a>)";
            }
        }
?>
            </td>
        </tr>
        </table>
        <table class="list_tab" border=0 width="100%">
        <tr  valign="top" class="siz12">
            <td align="left" width="20%">
<?php if($page>1) 
            {
                echo "<a href=\"$link_prev\"> Prev Page</a>";
            }
        else echo "&nbsp;";
?> 
            </td> 

            <td align="center" width="60%">
<?php
        // Page Index of the Listing
        $find		= "&page=$page";
        $replace	= "";
        $link_temp	= str_replace($find, $replace, $link_current);
        echo "<a href=\"$link_temp&amp;page=1\">First</a>";
        echo "&nbsp;&nbsp;&nbsp;&nbsp;";
        $split		= ceil($total_pages/10);
        $pg_index 	= 2;
        while($pg_index<$total_pages)
        {
            if(($pg_index % $split)==0)
            {
                echo "<a href=\"$link_temp&amp;page=$pg_index\">$pg_index</a>";
                echo "&nbsp;&nbsp;&nbsp;&nbsp;";
            }
            $pg_index=$pg_index+1;

        }

        if ($total_pages!=1)
            echo "<a href=\"$link_temp&amp;page=$total_pages\">Last</a>";

?>
            </td>			
            <td align="right" width="20%"> 
<?php   if($page<$total_pages) 
        {
            echo " <a href=\"$link_next\"> Next Page</a>";
        }
        else 
            echo "&nbsp;"; 
?> 
            </td>
        </tr>
        </table>
<?php 
        if($file_id||$category)
        {
?>
        <div style="dispaly:block;"> 
        <table class="list_tab" border=0 width="100%" >
          <tr>
            <td  width="45%">
<?php
            if ($_GET["edit"] || $show_input_method_selection_box)
            {
?>
          <ul class="editbar">
            <li>
            <form name="indicForm" method="GET" action="#">
                <div title="[Alt+K]Select language and Keyboard layout- Inscript, WX, RTS">
            <small>Keymap</small>
                <input type="hidden" name="offset" value="">
                <input type="hidden" name="convertFlag" value="">
                    <select name="selectLanguage" onChange="selectLang(this);">
                        <option selected>Select Keyboard Map</option>
                        <option label="inscript" value=-1>English</option>
                        <option label="inscript" value=0>Hindi - Inscript</option>
                        <option label="wx" value=0>Hindi - WX</option>
                        <option label="multi_hindi_rts">Hindi - RTS</option>
                        <option label="inscript" value=0>Marathi - Inscript</option>
                        <option label="wx" value=0>Marathi - WX</option>
                        <option label="multi_marathi_rts">Marathi - RTS</option>
                        <option label="multi_nepali_xkb">Nepali - XKB</option>
                        <option label="inscript" value=1>Bengali - Inscript</option>
                        <option label="wx" value=1>Bengali - WX</option>
                        <option label="inscript" value=2>Gurumukhi - Inscript</option>
                        <option label="wx" value=2>Gurumukhi - WX</option>
                        <option label="inscript" value=3>Gujarathi - Inscript</option>
                        <option label="wx" value=3>Gujarathi - WX</option>
                        <option label="inscript" value=4>Oriya - Inscript</option>
                        <option label="wx" value=4>Oriya - WX</option>
                        <option label="inscript" value=5>Tamil - Inscript</option>
                        <option label="wx" value=5>Tamil - WX</option>
                        <option label="multi_tamil_rts">Tamil - RTS</option>
                        <option label="inscript" value=6>Telugu - Inscript</option>
                        <option label="wx" value=6>Telugu - WX</option>
                        <option label="multi_telugu_rts">Telugu - RTS</option>
                        <option label="inscript" value=7>Kannada - Inscript</option>
                        <option label="wx" value=7>Kannada - WX</option>
                        <option label="inscript" value=8>Malayalam - Inscript</option>
                        <option label="wx" value=8>Malayalam - WX</option>
                </select>
                </div>
                <div title="[Alt+H]show hint menu for the keyboard map while typing(for selected keymaps only)"
                         id="div_keymap_hint" style="display:none">
                        <small> <u>H</u>int</small>
                        <input type="checkbox" name="chk_show_hint" onClick="togHintMenu();">
                </div>
                </form>
            </li>
          </ul>
<?php
            }
            else
                echo "&nbsp;";
?>
        </td>
        <td align="right" width="10%">
            <ul class="buttonbar">
            <li class="buttonlink">
                <span onMouseover="cssdropdown.dropit(this,event,'droplegends');">Legends</span></li>
            </ul>
        </td>	
        <td align="right" width="30%" >
<?php
            if ($_GET["edit_all"])
            {
?>
            <ul class="buttonbar">
                <li class="buttonlink"><a href="#" onClick="submitAllAndMove();">Submit Selected</a></li>
                <li class="buttonlink"><a href="#" onClick="checkAll()">Check All</a></li>
                <li class="buttonlink"><a href="#" onClick="clearAll();">Clear All</a></li>
            </ul>
<?php
            }
            else if($file_id || $category)
            {
                // Toggle the Visibility of both Currently Valid Translation and Most Popular Suggestion
?>
            <ul class="buttonbar">
                <li class="buttonlink">
                <a id="a_view" href="#" onClick="togClass('trans');">Hide Translation</a></li>
            </ul>
<?php			
            }
?>
        </td>
        <td align="right" width="15%">
            <ul class="buttonbar">
<?php
            if ($_GET["edit_all"])
            {
                $current_url	= $_SERVER['REQUEST_URI'];
                $find		= "&edit_all=".$_GET["edit_all"];
                $replace	= "";
                $current_url	= str_replace( $find, $replace, $current_url);
                $current_url	= htmlspecialchars($current_url);
                echo "<li class=\"buttonlink\"><a href=\"$current_url\" >Close All Edit</a></li>"; 
            }
            else
            {
                $current_url	= $_SERVER['REQUEST_URI'];
                $find		= "&edit=".$_GET["edit"];
                $replace	= "";
                $current_url	= str_replace($find, $replace, $current_url);
                $find		= "&skip=".$_GET["skip"];
                $current_url	= str_replace($find, $replace, $current_url);
                $find		= "&scrollPos=".$_GET["scrollPos"];
                $current_url	= str_replace($find, $replace, $current_url);
                $current_url	= $current_url . "&edit_all=yes";
                $current_url	= htmlspecialchars($current_url);
                echo "<li class=\"buttonlink\"><a href=\"$current_url\" >Edit All</a></li>";
            }
?>
            </ul>
        </td>
          </tr>
        </table>
        </div> 
<?php
        }
        $backimg="#ffffff";
?>


<?php
        if ($_GET["edit_all"])
        {
?>
        <form name="edit_all" method="POST" action="<?php echo $next_set; ?>">

<?php
        } 
?>
    <table  width="100%" border="0" cellpadding="5" cellspacing="0" class="tdborder">
        <tr class="siz12">
        <td width="1" bgcolor="<?php echo $backimg; ?>">
            <img src="images/spacer.png" width="1" height="20" alt=""></td>
        <td  class="tdright" align="center" bgcolor="<?php echo $backimg; ?>">
            <b>English String</b> </td>
        <td align="center" bgcolor="<?php echo $backimg; ?>">
            <div class="trans" style="display:block">
            <b>Valid / Popular Suggestion</b> </div></td>
        <td bgcolor="<?php echo $backimg; ?>" class="<?php if ($edit_all) echo "tdleft";?>">
<?php
        if ($edit_all)
            echo "<b>Submit</b>";
        else
            echo "&nbsp;";
?>
        </td>
<?php
        if ($edit_all)
        {
?>
            <td bgcolor="<?php echo $backimg; ?>" class="tdleft"><b>Fuzzy</b></td>
<?php
            if ($_SESSION['user_role'] == "validator")
            {
?>		    
                <td class="tdleft" align="right" bgcolor="<?php echo $backimg; ?>"><b>Validate</b></td>

<?php
            }
        }
?>
        <td width="1" bgcolor="<?php echo $backimg; ?>">
            <img src="images/spacer.png" width="1" height="20" alt="">
<?php

        if ($_GET["edit_all"])
        {
            echo '<input type="hidden" name="submit_all" value="yes">';
            if ($category)
            {
                echo '<input type="hidden" name="lang_sug" value="'.$lang.'">';
            }
            else if ($file_id)
            {
                echo '<input type="hidden" name="lang_sug" value="'.$file_lang.'">';
            }
        } 
?>
        </td>
        </tr>

<?php		

        $skip		= $_GET["skip"];
        $edit		= $_GET["edit"];
        $hide_edit_icon	= 0;
        do{
            /* Displaying each record in the list generated by $sql_list. Read Comments above.
             * The result of $sql_list is retrieved and strored in $row_list, row or record wise.
             */

            $display_edit_icon	= 1;
            $backimg=($backimg=="#ffffff")?"#efefef":"#ffffff";
            if ($file_list)
            {
                echo "<tr class=\"tdborder\">\n";
                echo "<td width=\"1\" bgcolor=\"$backimg\"> \n".
                    "<img src=\"images/spacer.png\" width=\"1\" height=\"20\" alt=\"\"></td>\n";
                if($file_id) // Listing Contents of a File
                {
                    /*   The "$sql_list" will generate the following details in that order
                     * string_id, string_value, context_id, valid_sug_id(id) or NULL for the $file_id.
                     *
                     *   valid_suggestion is retrieved, unlike list by "strings" (all strings or untranslated
                     * strings), as in most cases there is only one context
                     * for a string_value in a given $file_id.
                     */

                    echo "<td  bgcolor=\"$backimg\">\n";
                    $string_id	= $row_list[0];
                    printf("<a href=\"translate.php?file_list=%s&amp;file_id=%s&amp;funtrans=%s&amp;page=%d&amp;sid=%d\">%s</a>",
                        $file_list,$file_id,$funtrans,$page,$string_id,
                        htmlentities($row_list[1],ENT_COMPAT,'UTF-8'));
                    echo "</td>\n";

                    $skip_flag	= 0;
                    $select		= "edit=$edit";
                    $replace 	= "edit=$string_id";
                    $skip_1		= "skip=1";
                    $skip_0		= "skip=0";
                    $valid_sug	= '';
                    $popular_sug	= '';
                    $display_sug	= '';

                    echo "<td bgcolor=\"$backimg\" width=\"40%\" class=\"tdtrans\" >\n";
                    echo "<div class=\"trans\" style=\"display:block\">\n";
                    $display_sug 	= "";
                    if ($row_list[3]!='-1' )	// If valid_suggestion exists
                    {

                        $valid_sug_id	= $row_list[3];
                        $sql_valid_sug	= "select user_suggestion from $table_suggestion where ".
                            "sug_id = $valid_sug_id";
                        $result_valid_sug	= mysql_query($sql_valid_sug);
                        $valid_sug		= mysql_result($result_valid_sug,0,0);
                        $display_sug	= htmlentities ($valid_sug,ENT_COMPAT,'UTF-8');
                    }
                    else
                    {
                        $context_id    = $row_list[2];

                        // Get the Suggestion with the Maximum Vote for that context
                        $sql_high_vote 	= "select user_suggestion ".
                            "from $table_suggestion ".
                            "where string_id=$string_id and 
lang='$file_lang' ".
                            "order by vote desc limit 1";
                        $result_high_vote	= mysql_query($sql_high_vote);
                        if(mysql_num_rows($result_high_vote))
                        {
                            $row_high_vote 	= mysql_fetch_row($result_high_vote);
                            $popular_sug	= $row_high_vote[0];
                            $display_sug	= htmlentities($popular_sug,ENT_COMPAT,'UTF-8');
                        }
                    }

                    if ($_GET["edit_all"])
                    {
                        echo "<textarea name=\"sug_$string_id\"  class=\"indic_ime\" ".
                            "cols =\"40\" rows = \"2\">$display_sug</textarea>\n";
                    }
                    else
                    {
                        if ($edit && ($skip == -1))
                        {
                            $edit	= $string_id;
                        }

                        if ($edit == $string_id)
                        {
                            if ($skip == 1)
                            {
                                $skip 	= -1;
                                $skip_flag	= 1;
                            }
                            else
                            {
                                $pos_select  = "&scrollPos=".$_GET["scrollPos"];
                                $pos_replace = "";
                                $next_string = str_replace($select, $replace, $_SERVER['REQUEST_URI']);
                                $next_string = str_replace($skip_0, $skip_1, $next_string);
                                $next_string = str_replace($pos_select, $pos_replace, $next_string);

                                if (!strstr($next_string,$skip_1))
                                    $next_string = $next_string."&skip=1";

                                $next_string = htmlspecialchars($next_string);

?>

                        <form name="edit_form" method="POST" action="<?php echo $next_string; ?>">
                          <table border=0 align="center">
                            <tr>
                          <td colspan="3">
                                <textarea name="user_sug" class="indic_ime"   
                            cols="50" rows="2"><?php echo $display_sug; ?></textarea>
                          </td>
                            </tr>
                            <tr>
                          <td  align="left">
                                <a href="#" onClick="submitAndMove()" ><img 
                            src="images/submit.png" alt="Submit"></a>
                          </td>
                          <td align="center">
                            <input type="checkbox" name="fuzzy" >Fuzzy
                          </td>
                          <td align="center">
<?php
                                if ($_SESSION['user_role']=="validator")
                                { ?>
                            <input type="checkbox" name="check_valid" checked 
                                value="yes"/>Validate
<?php
                                } ?>
                            &nbsp;
                            <input type="hidden" name="string_id" 
                               value="<?php echo $string_id; ?>"/>
                            <input type="hidden" name="lang_sug" 
                               value="<?php echo $file_lang; ?>"/>
                          </td>
                            </tr>
                          </table>
                        </form>
<?php
                                $hide_edit_icon	= 1;
                                $skip		= 0;
                            }
                            if ($skip_flag)
                                echo "<a name=\"focus\"></a>";
                        }  

                        if ($skip_flag || $edit != $string_id)
                        {
                            if ($valid_sug) // If valid_suggestion exists
                            {
                                echo '<img src="images/valid.png" height="15" hspace=5 alt="Valid: ">';
                                printf(" %s ",$display_sug);
                                $valid_sug	= '';
                            }
                            else			// Search for Most Popular Suggestion
                            {
                                if($popular_sug !='')
                                {
                                    echo '<img src="images/vote215.png" height="15" hspace=5 alt="Popular">';
                                    printf(" %s",$display_sug);
                                    $popular_sug	= '';
                                }
                                else
                                    echo "<i>No Suggestion available</i>";
                            }
                        }
                    }


                    echo "</div>\n";
                    echo "</td>\n";

                    echo "<td width=\"10\" align=\"center\" bgcolor=\"$backimg\">\n";
                    if ($_GET["edit_all"])
                    {
                        echo "<input type=\"checkbox\" class=\"checkstring\" ".
                            "name=\"select_$string_id\" value=\"yes\">\n";
                    }
                    else if ($hide_edit_icon)
                    {
                        $find_edit          = $_GET["edit"];
                        $replace_edit       = "";
                        $find_skip          = $_GET["skip"];
                        $replace_skip       = "";
                        $find_scrollPos     = $_GET["scrollPos"];

                        $arg = "'$find_edit','$replace_edit','$find_skip','$replace_skip',";
                        $arg .= "'$find_scrollPos'";
                        echo '<a href="" onClick="return reDirect('.$arg.');">'.
                            '<img src="images/close.png" alt="Close"></a>';

                        $hide_edit_icon = 0;
                    }
                    else 
                    {
                        $find_edit          = $_GET["edit"];
                        $replace_edit       = $string_id;
                        $find_skip          = $_GET["skip"];
                        $replace_skip       = "0";
                        $find_scrollPos     = $_GET["scrollPos"];

                        $arg  = "'$find_edit','$replace_edit','$find_skip','$replace_skip',";
                        $arg .= "'$find_scrollPos'";
                        echo '<a href="" onClick="return reDirect('.$arg.');">'.
                            '<img src="images/edit.png" alt="Edit"></a>';
                    }
                    echo "</td>";

                    if ($edit_all)
                    {
?>
                    <td width="5" align="center" bgcolor="<?php echo $backimg; ?>">
                    <input  type="checkbox"  
                        name="<?php echo "fuzzy_$string_id"; ?>" value="yes"></td>
<?php
                        if ($_SESSION['user_role'] == "validator")
                        {	// Validate Suggestion
?>		    
                        <td width="5" align="center" bgcolor="<?php echo $backimg; ?>">
                        <input  type="checkbox" class="checkstring" 
                        name="<?php echo "valid_$string_id"; ?>" value="yes"></td>
<?php
                        }
                    }
                } 
                else		// File List
                {
                    /* The "$sql_list" will generate the following details in that order
                     * distinct file_id
                     */
                    echo "<td bgcolor=\"$backimg\" colspan=2>";
                    printf("<a href=\"$_SERVER[PHP_SELF]?file_list=%s&amp;file_id=%s&amp;page=1\">%s</a>",
                        $file_list,$row_list[0],htmlentities($row_list[1],ENT_COMPAT,'UTF-8'));
                    echo "</td>";
                }

                echo "<td width=\"1\" bgcolor=\"$backimg\">".
                    "<img src=\"images/spacer.png\" width=\"1\" height=\"20\" alt=\"\"></td>";
                echo "</tr>";
            } // End of - If FILE LIST
            else	// Listing Strings by Category : All or Only Untranslated strings
            {	
                /*   The "$sql_list" will generate the following details in that order
                 * distinct string_id, string_value
                 *   valid_suggestion is not retrieved by $sql_list as a string_value may have 
                 * multiple context and hence multiple valid_suggestion. This will lead to multiple 
                 * rows. Here we show a unique string in each row.
                 */
                echo "<tr class=\"tdborder\"> ";
                echo "<td width=\"1\"bgcolor=\"$backimg\" > ".
                    "<img src=\"images/spacer.png\" width=\"1\" height=\"20\" alt=\"\"></td>";
                echo "<td  bgcolor=\"$backimg\" >";
                printf("<a href=\"translate.php?category=%s&amp;page=%d&amp;sid=%d\">%s</a><br />",
                    $category,$page,$row_list[0],htmlentities($row_list[1],ENT_COMPAT,'UTF-8'));
                echo "</td>";

                $string_id	= $row_list[0];
                $skip_flag   = 0;
                $select      = "edit=$edit";
                $replace     = "edit=$string_id";
                $skip_1      = "skip=1";
                $skip_0      = "skip=0";
                $valid_sug	= '';
                $popular_sug	= '';
                $display_sug	= '';

                echo "<td bgcolor=\"$backimg\" class=\"tdtrans\" width=\"40%\">";
                echo "<div class=\"trans\" style=\"display:block\">";

                if ($category == "untrans")
                {
                    $add_cond	= "and valid_sug_id = -1 ";
                }	
                if ($lang && $lang != "all")
                {	
                    $sql_trans    = "select c.valid_sug_id, c.file_id, c.context_id ".
                        "from $table_string_context as c, $table_file_details as f ".
                        "where f.lang='$lang' $add_cond".
                        "and f.node_id=c.file_id and c.string_id=$string_id";
                }
                else
                {	
                    $sql_trans    = "select c.valid_sug_id, c.file_id, c.context_id, f.lang ".
                        "from $table_string_context as c, $table_file_details as f ".
                        "where f.node_id=c.file_id and ".
                        "c.string_id=$string_id $add_cond";
                }

                $result_trans = mysql_query($sql_trans);
                $num_trans	 = mysql_num_rows($result_trans);	// Number of Context 
                $sug_exists   = 0;


                while($row_trans    = mysql_fetch_row($result_trans))
                {
                    if($row_trans[0] != -1)	// If valid_suggestion exists
                    {
                        $valid_sug_id 	= $row_trans[0];
                        $sql_valid_sug	= "select user_suggestion from $table_suggestion where ".
                            "sug_id = $valid_sug_id";
                        $result_valid_sug	= mysql_query($sql_valid_sug);
                        $valid_sug		= mysql_result($result_valid_sug,0,0);
                        $valid_sug		= htmlentities($valid_sug,ENT_COMPAT,'UTF-8');
                        $display_sug	= $valid_sug;

                        if ( (($edit != $string_id && $skip != -1 )||($edit == $string_id && $skip==1)) 
                            && !$edit_all )
                        {
                            echo "<img src=\"images/valid.png\" height=\"15\" hspace=5 alt=\"\">";
                            printf(" %s ",$valid_sug);
                            $sug_exists   = 1;	
                        }
                    }
                    else if ($popular_sug && $lang && $lang!="all")	// Popular sug exists and lang known
                    {
                        if (!$display_sug)
                            $display_sug    = $popular_sug;

                        if ( (($edit != $string_id && $skip != -1 )||($edit == $string_id && $skip==1))
                            && !$edit_all )
                        {
                            echo "<img src=\"images/vote215.png\" height=\"15\" hspace=5 alt=\"\">";
                            printf(" %s ",$popular_sug);
                        }

                    }
                    else	// Search for the Most Popular suggestion	
                    {
                        $context_id	   = $row_trans[2];
                        if ($lang && $lang != "all")
                        {
                            $sql_high_vote 	= "select user_suggestion ".
                                "from $table_suggestion ".
                                "where lang ='$lang' and string_id=$string_id ".
                                "order by vote desc limit 1";
                        }
                        else
                        {
                            $sug_lang	= $row_trans[3];
                            $sql_high_vote 	= "select user_suggestion ".
                                "from $table_suggestion ".
                                "where string_id=$string_id and lang='$sug_lang' ".
                                "order by vote desc limit 1";
                        }
                        $result_high_vote	= mysql_query($sql_high_vote);
                        if (mysql_num_rows($result_high_vote))
                        {
                            $row_high_vote 	= mysql_fetch_row($result_high_vote);
                            $popular_sug	= $row_high_vote[0];
                            $popular_sug	= htmlentities($popular_sug,ENT_COMPAT,'UTF-8');
                            if ( (($edit != $string_id && $skip != -1 )||($edit == $string_id && $skip==1))
                                && !$edit_all )
                            {
                                echo "<img src=\"images/vote215.png\" height=\"15\" hspace=5 alt=\"\">";
                                printf(" %s ",$popular_sug);
                                $sug_exists	= 1;	
                            }
                            if (!$display_sug)
                                $display_sug    = $popular_sug;
                        }
                        else if($num_trans>1 && !$edit_all)
                        {
                            if ($skip != -1)
                            {
                                echo "No Suggestion available for";
                                $sug_exists	= 1;	
                            }
                        }
                    }
                    if($num_trans>1 && $sug_exists && !$edit_all) 
                        echo "<span class=\"fname\">(".getNodeName($row_trans[1]).")</span><br />";
                }

                if (!$edit_all && !$sug_exists && 
                    (($edit!=$string_id && $skip!=-1)||($edit==$string_id&&$skip==1)))
                    echo "No Suggestion available";

                if ($edit_all)
                {
                    echo "<textarea name=\"sug_$string_id\"  class=\"indic_ime\" ".
                        "cols =\"40\" rows = \"2\">$display_sug</textarea>\n";
                }
                else
                {
                    if ($skip == -1)
                        $edit 	= $string_id;

                    if ($edit == $string_id)
                    {
                        if ($skip == 1)
                        {
                            $skip 		= -1;
                            $skip_flag	= 1;
                        }
                        else
                        {
                            $pos_select  = "&scrollPos=".$_GET["scrollPos"];
                            $pos_replace = "";
                            $next_string = str_replace($select, $replace, $_SERVER['REQUEST_URI']);
                            $next_string = str_replace($skip_0, $skip_1, $next_string);
                            $next_string = str_replace($pos_select, $pos_replace, $next_string);

                            if (!strstr($next_string,$skip_1))
                                $next_string = $next_string."&skip=1";

                            $next_string = htmlspecialchars($next_string);

?>
                        <form name="edit_form" method="POST" action="<?php echo $next_string; ?>">
                            <table border=0 align="center">
                            <tr>
                            <td colspan="3">
                                    <textarea name="user_sug" class="indic_ime" 
                                    cols  = "50" rows = "2"><?php 
                            echo $display_sug; ?></textarea>
                            </td>
                        </tr>
                        <tr>
                            <td  align="left">
                                    <a href="#" onClick="submitAndMove()" ><img 
                               src="images/submit.png" alt="Submit"></a>
                            </td>
                            <td align="center">
                              <input type="checkbox" name="fuzzy" >Fuzzy
                             </td>
                            <td align="center">
<?php					    	        if ($_SESSION['user_role']=="validator")
                            { ?>
                                <input type="checkbox" name="check_valid" value="yes"/>Validate
<?php					    	        } ?>
                                &nbsp;
                                <input type="hidden" name="string_id" 
                               value="<?php echo $string_id; ?>"/>
                                <input type="hidden" name="lang_sug" 
                               value="<?php echo $lang; ?>"/>
                            </td>

                            </tr>
                            </table>
                        </form>
<?php
                            $hide_edit_icon	= 1;
                            $skip		= 0;
                        }
                        //				    if ($skip_flag)
                        //				        echo "<a name=\"focus\"></a>";
                    }  

                    $loc = "'$_SERVER[PHP_SELF]?category=$category&file_list=$file_list&file_id=$file_id&".
                        "funtrans=$funtrans&page=$page&edit=$string_id&skip=0'";
                }
?>
               </div>
               </td>
               <td width="10" bgcolor="<?php echo $backimg; ?>">
<?php			   if ($edit_all)
                            {
?>
                <input type="checkbox" class="checkstring" 
                     name="<?php echo "select_$string_id"; ?>" value="yes">

<?php			   }
else if ($hide_edit_icon)
{
    $find_edit          = $_GET["edit"];
    $replace_edit       = "";
    $find_skip          = $_GET["skip"];
    $replace_skip       = "";
    $find_scrollPos     = $_GET["scrollPos"];

    $arg = "'$find_edit','$replace_edit','$find_skip','$replace_skip',";
    $arg .= "'$find_scrollPos'";
    echo '<a href="" onClick="return reDirect('. $arg.');">'.
        '<img src="images/close.png" alt="Close"></a>';

    $hide_edit_icon = 0;
}
else
{
    $find_edit          = $_GET["edit"];
    $replace_edit       = $string_id;
    $find_skip          = $_GET["skip"];
    $replace_skip       = "0";
    $find_scrollPos     = $_GET["scrollPos"];

    $arg = "'$find_edit','$replace_edit','$find_skip','$replace_skip',";
    $arg .= "'$find_scrollPos'";
    if ($lang && $lang != "all")
    {
        echo '<a href="" onClick="return reDirect('.$arg.');">'.
            '<img src="images/edit.png" alt="Edit"></a>';
    }
    else
    {
        echo '<a href="" onClick="return warnLang();">'.
            '<img src="images/edit.png" alt="Edit"></a>';
    }
}
echo "</td>";
if ($edit_all)
{
?>
                <td width="5" align="center" bgcolor="<?php echo $backimg; ?>">
                    <input  type="checkbox"  
                    name="<?php echo "fuzzy_$string_id"; ?>" value="yes">
                </td>
<?php
    if ($_SESSION['user_role'] == "validator")
    {
?>		    
                    <td width="5" align="center" bgcolor="<?php echo $backimg; ?>">
                        <input  type="checkbox" class="checkstring" 
                        name="<?php echo "valid_$string_id"; ?>" value="yes">
                    </td>
<?php
    }
}
?>
               <td width="1" bgcolor="<?php echo $backimg; ?>">
                <img src="images/spacer.png" width="1" height="20" alt=""></td>
               </tr>		
<?php
            }

        }while($row_list = mysql_fetch_row($list_result));
?>

    </table>
<?php
        if ($_GET["edit_all"])
        {
            echo "\n</form>";
        }		
?>
        <!--	Page Index Table	-->
        <table width="100%"  border=0 cellpadding="5">
        <tr  valign="top" class="siz12">
            <td align="left" width="33%">
<?php if($page>1) 
        {
            echo "<a href=\"$link_prev\"> Prev Page</a>";
        }
        else echo "&nbsp;";
?> 
            </td> 

            <td align="center" width="34%">
<?php
        // Page Index of the Listing
        $find		= "&page=$page";
        $replace	= "";
        $link_temp	= str_replace($find, $replace, $link_current);
        echo "<a href=\"$link_temp&amp;page=1\">First</a>";
        echo "&nbsp;&nbsp;&nbsp;&nbsp;";
        $split		= ceil($total_pages/10);
        $pg_index 	= 2;
        while($pg_index<$total_pages)
        {
            if(($pg_index % $split)==0)
            {
                echo "<a href=\"$link_temp&amp;page=$pg_index\">$pg_index</a>";
                echo "&nbsp;&nbsp;&nbsp;&nbsp;";
            }
            $pg_index=$pg_index+1;

        }

        if ($total_pages!=1)
            echo "<a href=\"$link_temp&amp;page=$total_pages\">Last</a>";

?>
            </td>			
            <td align="right" width="33%" > 
<?php   if($page<$total_pages) 
        {
            echo " <a href=\"$link_next\"> Next Page</a>";
        }
        else 
            echo "&nbsp;"; 
?> 
            </td>
        </tr>
        </table>
<?php
    }
    else if($file_id || $category)
    {
        insertLangForm($lang, $lang_list);
        echo "<center><br /><br /><i> No Strings available for this category </i></center>";
    }
    else
    {
        echo "<center><br /><br /><i> No Files are loaded into the database </i></center>";
    }

?>
<!--
  </td>
</tr>
</table>
-->
</div> 

<div id="droplegends" class="dropmenudiv" >
    <span>
        <img src="images/valid.png" height="15" hspace=5 alt="Valid: "> &nbsp; Valid Translation
    </span>
    <span>
        <img src="images/vote215.png" height="15" hspace=5 alt="Valid: "> &nbsp; Most Popular Suggestion
    </span>
</div>

    <script type="text/javascript">
    <!--
        var scrollPos = "<?php echo "{$_GET['scrollPos']}"; ?>";
    if(!scrollPos)
        scrollPos = 0;

    setScrollPos(scrollPos);
    //-->
    </script>

<?php

    mysql_close($db);

    include ("footer.php");

?>
