/*
 * translate.js
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */

    
//variable iexplore will be set if the browser is Internet Explorer
var iexplore = !window.opera && (window.event || document.all);
var classAttrib = (iexplore) ? "className":"class";
var scriptFilePath = "scripts/";

var checked_sug_index;

document.onkeypress = eventCaptured;// For IE & Netscape
document.onkeydown = ieEvent;  //for IE

function ieEvent(evt)      //keypress event can't recognize control keys
{
    var key;
    if(iexplore) {
        key = window.event.keyCode;
        if((window.event.altKey && key != 18) || key == 8 || key == 46) { 
            //key value 18 is for 'alt' key itself , 8 for backspace, 46 for delete
            eventCaptured(evt);
        }
    }
}

/*
This function is called in response to keypress event. This inturn calls the eventHandler function by sending
the target element and the event, if convertion is needed from english to indic language.
*/
function eventCaptured(evt)
{
//alert("eventCaptured");
    var target,event;
    var keyCode,sug_id,comments,button_name;

    if(iexplore) {  //if the browser is IE
        event = window.event;
        target = window.event.srcElement;
        keyCode = event.keyCode;    //get the key code of the key which triggers the event
    }
    else { //for other browsers
        event = evt;
        target = evt.target;
        keyCode = event.which;
    }
//alert(keyCode);
    if(event.altKey) {
        switch(keyCode) {
            case 49:
            case 50:
            case 51:
            case 52:
            case 53:
            case 54:
            case 55:
            case 56:
            case 57:
                if(!document.trans_form.selected_suggestion_id ||
                  !document.trans_form.selected_suggestion_id.length ||
                  (keyCode-49)>=document.trans_form.selected_suggestion_id.length)
                    return;
        
                comments = "";
                document.trans_form.selected_suggestion_id[keyCode-49].checked=true;
                checked_sug_index=keyCode-49;
                document.trans_form.user_sug.value = document.getElementsByName("selected_suggestion_id")[keyCode-49].getAttribute('alt');
          
  		        document.trans_form.user_comments.disabled = false;
                button_name = "Submit My Suggestion";
                
                sug_type = document.trans_form.selected_suggestion_id[keyCode-49].value;
                
                if(sug_type != "user" && sug_type != "mach") {
   		  	        sug_id = document.trans_form.selected_suggestion_id[keyCode-49].value;
                    comments = document.getElementsByName("comments"+sug_id).item(0).value;
                    button_name = "Validate";
                    
 			        if(user_role!="validator") {
				        document.trans_form.user_comments.disabled = true;
		  	            button_name = "Vote";
			        }
		        }
		        
                document.trans_form.user_comments.value = comments;
                document.trans_form.submit_suggestion.value = button_name;
		        document.trans_form.user_sug.focus();
                prevent(event);
                break;
            case 110:              //Next
            case 78:
                window.location=link_next;    //variable link_next is defined in translate.php
                prevent(event);
                break;
            case 112:              //Previous
            case 80:
                window.location=link_prev;    //variable link_prev is defined in translate.php
                prevent(event);
                break;
            case 107:              //Keyboard Layout
            case 75:
                document.indicForm.selectLanguage.focus();
                prevent(event);
                break;
            case 115:              //Suggestion
            case 83:
                document.trans_form.user_sug.focus();
                prevent(event);
                break;
            case 104:              //Hint Menu - Toggling
            case 72:
                if(document.getElementById('div_keymap_hint').style.display == 'none') {
                    break;
                }
                if(document.indicForm.chk_show_hint.checked) {
                    document.indicForm.chk_show_hint.checked = false;
                }
                else {
                    document.indicForm.chk_show_hint.checked = true;
                }
                togHintMenu();      //function has been defined inside 'IndicSupport.js'
                prevent(event);
                break;
            case 109:              //Auto suggestion Toggling
            case 77:
                if(document.indicForm.auto_sug.checked) {
                    document.indicForm.auto_sug.checked = false;
                }
                else {
                    document.indicForm.auto_sug.checked = true;
                }
                togViewAutoSug(); 
                prevent(event);
                break;
        }
        if(keyCode == 13 && target.type == "textarea" && (target.getAttribute(classAttrib) == "indic_ime"
           ||target.getAttribute(classAttrib) == "user_comments")) {
           
            if(event.ctrlKey) {
                t_validate();   //this function has been defined in translate.php
            }
            else {
                sub_continue();   //this function has been defined in translate.php
            }
        }
        return;
    }
    if(target.type=="textarea" && target.getAttribute(classAttrib) == "indic_ime")
    {
        if(keyCode == 13) {
            prevent(event);     //disable ENTER key, no newline characters allowed
            return;
        }
        if(document.trans_form.selected_suggestion_id &&
           document.trans_form.selected_suggestion_id.length && 
           document.trans_form.selected_suggestion_id[checked_sug_index].value != "user" &&
           !isCtrlKey(event,iexplore))
        {   
            //for any key
            checked_sug_index=document.getElementsByName('selected_suggestion_id').length-1;
            document.trans_form.selected_suggestion_id[checked_sug_index].checked=true;
            document.trans_form.user_comments.disabled = false;
            document.trans_form.submit_suggestion.value = "Submit My Suggestion";
        }
    }
    if(document.indicForm.convertFlag.value != "true")  //hidden field, tells whether convertion should take place or not
        return;
    eventHandler(target,event);  //event handler of specific file that handles specific keyboard layout
}

function prevent(event) {
    if(event.preventDefault){
        event.preventDefault();
    }
    else {
        event.returnValue = false;
    }
    if(iexplore) {
        //if the key combination is already defined for some shortcuts
        //the following line is necessary to prevent that functionality 
        window.event.keyCode=0;
    }
}
    
    
    function findCheckedSuggestion()
    {
        if(!document.trans_form.selected_suggestion_id ||
           !document.trans_form.selected_suggestion_id.length)
        {
            checked_sug_index=-1;
            return;
        }

        for (var i=0; i<document.trans_form.selected_suggestion_id.length;i++)
            if(document.trans_form.selected_suggestion_id[i].checked)
                checked_sug_index=i;
    }
   
    function togDiv(id)
    {
        el = document.getElementById(id);
        if(el.style.display == 'none')
        {
            el.style.display = 'block';
        }
        else
        {
            el.style.display = 'none';
        }
    }


    function popup(mylink, windowname)
    {
        if (! window.focus)return true;
            var href;
        if (typeof(mylink) == 'string')
            href = mylink;
        else
            href = mylink.href;
        window.open(href, windowname,'width=600,height=550,resizable=yes,scrollbars=yes');
        return false;
    }
    function togUserText()  // Toggle user input area
    {
        var sug_id, comments, button_name;
        comments        = "";
        document.trans_form.user_comments.disabled = false;

        if(!document.trans_form.selected_suggestion_id.length)
            return;

        for (var i=0; i<document.trans_form.selected_suggestion_id.length;i++)
        {
            if(document.trans_form.selected_suggestion_id[i].checked) 
            {
                checked_sug_index=i;
                sug_type = document.trans_form.selected_suggestion_id[i].value;
                if(sug_type != "user" && sug_type != "mach") 
                {
                    sug_id      = document.trans_form.selected_suggestion_id[i].value;
                    comments    = document.getElementsByName("comments"+sug_id).item(0).value;
                    if(user_role!="validator") 
                    {
                        button_name = "Vote";
                        document.trans_form.user_comments.disabled 	= true;
                    }
                    else
                    {
                        button_name = "Validate";
                    }
                }
                else
                {
                    button_name = "Submit My Suggestion";
                }

                document.trans_form.submit_suggestion.value = button_name;
                document.trans_form.user_comments.value     = comments;
                document.trans_form.user_sug.value          = document.getElementsByName("selected_suggestion_id")[i].getAttribute('alt');
                is_fuzzy                                    = document.getElementsByName("selected_suggestion_id")[i].getAttribute('label');
                document.trans_form.is_fuzzy.checked        = (is_fuzzy==1) ? true : false;
		        document.trans_form.user_sug.focus();
		        break;
            }
        }
    }
   
function togViewAutoSug()
{
    var href	= window.location.pathname + window.location.search;
    var new_href;
    if (document.indicForm.auto_sug.checked == true)
    {
	new_href	= href.replace('auto=-1',"auto=1");
	if (href == new_href)
	{
	    new_href	= href + "&auto=1";
	}
    }
    else if (document.indicForm.auto_sug.checked == false)
    {
	new_href	= href.replace('auto=1',"auto=-1");
	if (href == new_href)
	{
	    new_href	= href + "&auto=-1";
	}
    }
    window.location	= new_href;
}

function setLang(old_lang)
{
    var lang_sel  = document.trans_form.lang_sel;
    var index     = lang_sel.selectedIndex;
    var lang 	  = lang_sel.options[index].value;    
    var href	  = window.location.href;
    var new_href  = href.replace('&lang='+old_lang, "");
    if(lang) 
    {
    	new_href	  += '&lang=' + lang;
    }
    window.location = new_href;
}
